#!/usr/bin/env python
# -*- coding:utf-8 -*-

import re,datetime,time,os,struct,sys,commands
import pyinotify
import json
from collections import OrderedDict
from hashlib import md5

base_time=datetime.datetime.now().strftime('%Y-%m-%d')
status='status installed'
new_dpkg_info=[]
base_dpkg_info=[]
sub=re.compile('\d+')
all_info=OrderedDict()


class DpkgChangeInotify(pyinotify.ProcessEvent):


	def process_IN_MODIFY(self,event):
		print 'modify event:' +event.pathname
		write_osinfo()
		base_time=get_base_time()
		sync_base_time(base_time)


def get_base_time():
	with open('/etc/kylin_osname_update','r') as f:
		a=f.readlines()[1]
		time_list=sub.findall(a)
		base_time='{}-{}-{} {}:{}:{}'.format(time_list[0],time_list[1],time_list[2],time_list[3],time_list[4],time_list[5])
	return time.mktime(time.strptime(base_time,'%Y-%m-%d %H:%M:%S'))


def check_soft(deb):
	list=os.popen('dpkg -L '+deb).readlines()
	if '/opt\n' not in list:
		return True
	else:
		return False


def check_os_type():
	OSTYPE=''
	VERSION=''
	with open('/etc/lsb-release') as f:
		info=f.readlines()
		ostype=info[1].split('=')[1].split('.')[4]
		msg, architecture=commands.getstatusoutput("arch")
		if "mips64" in architecture:
			cpuinfo=os.popen("lscpu").readlines()[8].split('(')[1].split(')')[0]
		else:
			cpuinfo=''.join([i for i in os.popen('lscpu').readlines() if "Model name" in i]).strip()

		if ostype.startswith('D') and "FT-1500" in cpuinfo:
			OSTYPE='桌面'
			VERSION='SV2.3.2'
		elif ostype.startswith('D') and "FT-2000" in cpuinfo:
			OSTYPE='桌面'
			VERSION='SV2.14.2'
		elif ostype.startswith('S') and "FT1500A" in cpuinfo:
			OSTYPE='服务器'
			VERSION='SVS2.5.2'
		elif ostype.startswith('S') and "FT2000PLUS" in cpuinfo:
			OSTYPE='服务器'
			VERSION='SVS2.15.2'
		elif ostype.startswith('D') and "3A3000" in cpuinfo:
			OSTYPE='桌面'
			VERSION='SV2.6.2'
		elif ostype.startswith('D') and "3A4000" in cpuinfo:
			OSTYPE='桌面'
			VERSION='SV2.11.2'
		elif ostype.startswith('S') and "3B3000" in cpuinfo:
			OSTYPE='服务器'
			VERSION='SVS2.8.2'
		elif ostype.startswith('S') and "3B4000" in cpuinfo:
			OSTYPE='服务器'
			VERSION='SVS2.10.2'
		f.close()
		return OSTYPE,VERSION


def sync_base_time(base_time):

	with open('/var/log/dpkg.log','r') as f:
		a=f.readlines()[-1].split(' ')
		if a[3] == 'installed':
			new_time=a[0]+' '+a[1]
			new_base_time=time.mktime(time.strptime(new_time,'%Y-%m-%d %H:%M:%S'))
			if int(new_base_time) > int(base_time):
				deb=a[4].split(':')[0]
				#print deb
				#a=check_soft(deb)
				#print a
				if check_soft(deb):
					#print j
					#print base_dpkg_info
					date_list=a[:2]
					year=date_list[0].split('-')[0]
					month=date_list[0].split('-')[1]
					day=date_list[0].split('-')[2]
					hour=date_list[1].split(':')[0]
					minute=date_list[1].split(':')[1]
					second=date_list[1].split(':')[2]
					ostype,version=check_os_type()
					print ostype,version
					with open('/etc/kylin_osname_update','w+') as x:
						x.write('osname=银河麒麟'+ostype+'操作系统(涉密专用版'+version+')\n')
						x.write('update='+year+'年'+month+'月'+day+'日 '+hour+':'+minute+':'+second+'\n')
						x.close()
		f.close()

def base_info():
	osbaseinfo={}
	osinfo={}
	a=OrderedDict()
	b=OrderedDict()

	with open('/etc/.systeminfo','r') as f:
		info=f.readlines()
		name=info[1].split('=')[1].strip()
		#print name
		osversion=info[4].split('=')[1].strip()
		kernelversion=info[3].split('=')[1].strip()
		#arch=re.split('/| ',info[6].split('=')[1])[1].strip()
		msg, architecture=commands.getstatusoutput("arch")
		if "mips64" in architecture:
			arch=os.popen('archdetect').readlines()[0].split('/')[0]
		else:
			msg, arch=commands.getstatusoutput('arch')
		desc=info[2].split('=')[1].strip()
		serial=info[2].split('版')[1].split(')')[0]
		with open('/etc/kylin-build','r') as n:
			date=n.readlines()[1].strip()
			osdate=date.split(' ')[1].split('.')[0][0:8]
			n.close()
		a['name']=name
		a['osversion']=osversion
		a['kernelversion']=kernelversion
		a['arch']=arch
		a['desc']=desc
		b['name']=name
		b['osversion']=osversion
		b['kernelversion']=kernelversion
		b['arch']=arch
		b['osdate']=osdate
		b['desc']='送测版本'
		b['serial']=serial

		all_info['osbaseinfo']=a
		all_info['osinfo']=b
		#print all_info
		f.close()

def deb_info():
	patch_list=[]
	#whitelist=[{'filepathname':'xxx','filehash':'xxx'},{'filepathname':'xxx','filehash':'xxx'},{'filepathname':'xxx','filehash':'xxx'}]
	#time_now=' '.join(os.popen('cat /var/log/dpkg.log |grep stime-sync').readlines()[0].split(' ')[0:2])
	time_now=datetime.datetime.now().strftime('%Y-%m-%d')
	print time_now
	#print time_now
	with open('/var/log/dpkg.log') as f:
		a=f.read()
		flag=a.find(time_now)

		b=a[flag:]
		debline=b.split('\n')
		#print debline
		for i in debline:
			#print i
			patch_chlid=OrderedDict()
			if i and i.split(' ')[2] == 'status' and i.split(' ')[3] == 'installed' and i.split(' ')[4].split(':')[0]:
				debname=i.split(' ')[4].split(':')[0]
				print debname
				version=os.popen('dpkg -l '+debname+'|grep ^ii').readline()
				print version
				try:

					print i.split(' ')[4].split(':')[0]
					status,hashvalue,whitelist=check_deb(i.split(' ')[4].split(':')[0],version)
				except:
					continue
				print status,hashvalue,whitelist
				if status :
					print i
					name=i.strip().split(' ')[4].split(':')[0]
					version=i.strip().split(' ')[5]
					arch=i.strip().split(' ')[4].split(':')[1]
					desc=' '.join(os.popen('dpkg -l '+name+'|grep ^ii').read().split()[4:])
					patch_chlid['patchname']=name
					patch_chlid['patchversion']=version
					patch_chlid['arch']=arch
					patch_chlid['patchhash']=hashvalue
					patch_chlid['desc']=desc
					patch_chlid['whitelist']=whitelist
					patch_list.append(patch_chlid)
		f.close()
	#print patch_list
	all_info['ospatch']=patch_list


def pp_check():
	pp_list=os.popen("ls /etc/selinux/ukmcs/modules/active/modules/").readlines()
	List=[]
	Dir="/etc/selinux/ukmcs/modules/active/modules/"

	for line in pp_list:
		Dic={}
		a = line.strip("\n")
		filepath = os.path.join(Dir,a)
		x = os.popen("cal-file-sm3 " + filepath)
		b = x.readline().strip()
		#print b
		Dic["filehash"] = b
		Dic["filepathname"] = filepath
		List.append(Dic)
		num = len(List)
	all_info['pp']=List

def check_deb(name,version):
	#httc_list=[]
	whitelist=[]
	varlst=os.walk('/root')
	for i in varlst:
		for j in i[2]:
			deb_path=os.path.join(i[0],j)

			#tmp=':'.join(httc_list)
			if name in deb_path:
				tmp=os.popen('dpkg --info '+deb_path).readlines()
				for z in tmp:
					if z.strip().startswith('Version'):
						ver=z.strip().split(' ')[1]
						if ver in version:
							hashvalue=os.popen('md5sum '+deb_path).read().split()[0]
							name_lines=os.popen('dpkg -L '+name).readlines()
							whitelist=[]
							for file_path in name_lines:
								file_dic=OrderedDict()
								path=file_path.strip()
								if os.path.isfile(path) and filetype(path):
									file_dic['filepathname']=path
									file_dic['filehash']=os.popen("cal-file-sm3 " + path).readline().strip()
									whitelist.append(file_dic)
								else:
									continue
							return True,hashvalue,whitelist
						else:
							continue
					else:
						continue
			else:
				continue


def bytes2hex(bytess):
	num=len(bytess)
	hexstr=u""
	for i in range(num):
		t=u"%x" %bytess[i]
		print t
		if len(t) % 2:
			hexstr += u"0"
		hexstr += t
	return hexstr.upper()


def filetype(filename):
	fsize=os.path.getsize(filename)

	binfile=open(filename,'rb')
	numBytes=6
	binfile.seek(0)
	if fsize >= numBytes:
		try:
			hbytes=struct.unpack_from('B'*numBytes,binfile.read(numBytes))
		except struct.error as err:
			print "file error:%s" %err
			return False
		print hbytes
		f_hcode=bytes2hex(hbytes)
		binfile.close()
		filetype=f_hcode.encode('utf-8')
		if filetype == '23212F757372' or filetype == '2321202F7573':
			print '%s is perl or python script' %filename
			return True
		elif filetype == '23212F62696E' or filetype == '2321202F6269':
			print '%s is shell script' %filename
			return True
		elif filetype == '7F454C460201':
			print '%s is binary file' %filename
			return True
		else:
			print '%s is not execfile.' %filename
			return False
	else:
		print '%s file size less then 6 bytes!' %filename
		return False


def write_osinfo():
	base_info()
	deb_info()
	pp_check()
	if os.path.exists('/etc/.os_info_base_patch'):
		with open("/etc/.os_info_base_patch",'r') as f:
			a=f.read()
			flag=a.find('"ospatch": [')+5
			#print flag
			for i in all_info['ospatch']:
				text=json.dumps(i, ensure_ascii=False, indent=4, sort_keys=True)
				#print text
				if a[flag+7] == "]":
					with open("/etc/.os_info_base_patch","w+") as x:
						x.write(json.dumps(all_info, ensure_ascii=False, indent=4, sort_keys=True))
						x.close()

				else:
					content=a[:flag+len(i)+1]+text+','+a[flag+len(i)+1:]
					#print content
					x=open('/etc/.os_info_base_patch','w+')
					x.write(content)
					x.close()
			f.close()
		with open("/etc/.os_info_base_patch",'r') as f:
			a=f.read()
			pp_flag=a.find('"pp": [')
			#print 'pp_flag:%d\n' %pp_flag
			j=all_info['pp']
			head='"pp": '
			text=json.dumps(j, ensure_ascii=False, indent=4, sort_keys=True)
			content=a[:pp_flag]+head+text+'}'
			x=open('/etc/.os_info_base_patch','w+')
			x.write(content)
			x.close()

			f.close()
	else:

		with open("/etc/.os_info_base_patch","w+") as x:
			x.write(json.dumps(all_info, ensure_ascii=False, indent=4, sort_keys=True))
			x.close()

if __name__ == '__main__':
	wm=pyinotify.WatchManager()
	wm.add_watch('/var/log/dpkg.log',pyinotify.ALL_EVENTS,rec=True)
	eh=DpkgChangeInotify()
	notifier=pyinotify.Notifier(wm,eh)
	notifier.loop()
