#!/usr/bin/env python
# -*- coding:utf-8 -*-

import os,sys,dbus,getpass,commands,time
from dbus.mainloop.glib import DBusGMainLoop
import gobject
from PyQt4 import QtGui
from syncGui import Example
import shutil

VERSION = "v10-sync-soft.0.4"

def showprogeress(spath,dpath):
	app = QtGui.QApplication(sys.argv)
	ex = Example(spath,dpath)
	ex.show()
	sys.exit(app.exec_())

def copy_q7(mode, workdir):
	"""copy p7 for optional install"""

	if mode == "1500": platform = "11"
	elif mode == "2000": platform = "12"
	elif mode == "3000": platform = "19"
	elif mode == "4000": platform = "20"
	print "cpu = " + mode + ", platform = " + platform

	# /var/ZYJInstallGuide/workdir/soft_dir/file_list
	# e.g /var/ZYJInstallGuide/流式软件/yozo-office/yozo-office-...-arm64.q7
	soft_dir = os.listdir(workdir)
	for soft in soft_dir:
		#print soft
		file_dir = os.path.join(workdir, soft)
		file_list = os.listdir(file_dir)
		for f in file_list:
			if ((f.find(platform + ".q7")) > 0):
				srcfile = os.path.join(file_dir, f)
				#print "src:" + srcfile
			if ((f.find("deb.q7")) > 0):
				destfile = os.path.join(file_dir, f)
				#print "dest:" + destfile
		shutil.copyfile(srcfile, destfile)

def copy_preinstall(mode, ospath, threeinone):
	"""copy soft for preinstall"""

	if threeinone == "14": threeinone_name = "汉邦三合一"
	elif threeinone == "08": threeinone_name = "金城三合一"
	elif threeinone == "04": threeinone_name = "中孚三合一"
	elif threeinone == "07": threeinone_name = "万里红三合一"
	elif threeinone == "24": threeinone_name = "世安三合一"
	elif threeinone == "03": threeinone_name = "朗威三合一"
	elif threeinone == "05": threeinone_name = "鼎普三合一"

	if os.path.exists(ospath):
		os.system("mv /var/softmanager/preinstall-tmp/预装软件/%s/* /var/softmanager/preinstall-tmp/ && mv /var/softmanager/preinstall-tmp/预装软件/%s/*.deb /var/softmanager/preinstall-tmp/ && mv /var/softmanager/preinstall-tmp/预装软件/*.deb /var/softmanager/preinstall-tmp/" % (mode, threeinone_name))



def mount_added(sender,id_,data):
	print "mount func ...."
	user_name=getpass.getuser()
	cpu_type=os.popen("uname -r").readline().split('.')[3]
	status1,cd_name1=commands.getstatusoutput("cd /media/root && find ./ -name 流式软件|awk -F '/' '{print $2}'")
	status2,cd_name2=commands.getstatusoutput("cd /media/root && find ./ -name 版式软件|awk -F '/' '{print $2}'")
	status4,cd_name4=commands.getstatusoutput("cd /media/root && find ./ -name 预装软件|awk -F '/' '{print $2}'")
	status3,mount_name=commands.getstatusoutput("df |grep sr0")
	if user_name == "root" and cpu_type == "D001" and str(status1) == "0" and str(status2) == "0" and str(status3) == "0" and str(status4) == "0" and cd_name1 and cd_name2 and cd_name4 in mount_name:
		try:
			os.system("notify-send '正在同步预装软件，完成后将自动弹出光盘介质!'")
		except Exception as err:
			print err 
		os.system("mkdir -p /root/cd-mnt")
		time.sleep(1)
		os.system("umount /dev/sr0 -l")
		time.sleep(1)
		os.system("mount /dev/sr0 /root/cd-mnt")

		msg, arch=commands.getstatusoutput("arch") 
		if arch == "mips64":
			cpu_string = [i for i in os.popen("LANG=C lscpu").readlines() if "Model name" in i][0].split('(')[1].split(')')[0][-4:]
		else:
			cpu_string = [i for i in os.popen("LANG=C lscpu").readlines() if "Model name" in i][0].split('-')[1].split('/')[0][0:4]
		print "cpu_string: " + cpu_string

		threeinone_string=os.popen("cat /etc/3in1.info").readlines()[0].strip().split('-')[1].split('.')[0]
		try:
			if not os.path.exists("/var/softmanager/preinstall-tmp"):
				os.system("mkdir -p /var/softmanager/preinstall-tmp")

			if os.path.exists("/var/ZYJInstallGuide"):
				pass
			else:
				os.system("mkdir -p /var/ZYJInstallGuide")
			child = os.fork()
			if (not child):
				showprogeress('/root/cd-mnt/*','/var/ZYJInstallGuide/')
				os._exit(0)
			os.waitpid(child, 0)
			child = os.fork()

			if (not child):
				os.system("rm -f `find /var/ZYJInstallGuide/ -name 'TRANS.TBL'`")
				dir_list = os.listdir("/var/ZYJInstallGuide/")
				for dir in dir_list:
					if os.path.isdir('/var/ZYJInstallGuide/' + dir) and not dir == "预装软件":
						#print "copy q7 for dir: " + dir
						copy_q7(cpu_string, '/var/ZYJInstallGuide/' + dir)

				os.system("mv /var/ZYJInstallGuide/预装软件 /var/softmanager/preinstall-tmp/")
				os.system("chmod 777 /var/ZYJInstallGuide/ -R")

				## copy soft for preinstall
				copy_preinstall(cpu_string, '/root/cd-mnt/预装软件/'+cpu_string, threeinone_string)

				os.system("rm /var/softmanager/preinstall-tmp/预装软件/ -rf")
				os._exit(0)

			os.waitpid(child, 0)
			os.system("chown secadm.secadm -R /var/softmanager")
			os.system("chmod 777 -R /var/softmanager")
			os.system("rm -rf /var/softmanager/preinstall/ && mv /var/softmanager/preinstall-tmp/ /var/softmanager/preinstall/")
			os.system("notify-send '预装软件包同步完毕，重启系统后请通过安全管理员登录，在预选工具里进行选择安装!'")
			os.system("umount /root/cd-mnt -l")
			os.system("rm /root/cd-mnt -rf")
			os.system("eject")

		except Exception as err:
			cont='预装软件同步失败:{}'.format(err)
			os.system("notify-send "+cont)
			os.system("umount /root/cd-mnt -l")
			os.system("rm /root/cd-mnt -rf")
			os.system("eject")

	elif user_name == "root" and cpu_type == "S001" and str(status3) == "0" and str(status4) == "0" and cd_name4 and mount_name:

		try:
			os.system("notify-send '正在同步预装软件，完成后将自动弹出光盘介质!'")
		except Exception as err:
			print err
		os.system("mkdir -p /root/cd-mnt")
		time.sleep(1)
		os.system("umount /dev/sr0 -l")
		time.sleep(1)
		os.system("mount /dev/sr0 /root/cd-mnt")
		cpu_string=[i for i in os.popen("lscpu").readlines() if "Model name" in i][0]
		child = os.fork()
		if (not child):
			showprogeress('/root/cd-mnt/*','/var/softmanager/preinstall-tmp/')
		os.waitpid(child, 0)
		child = os.fork()
		if (not child):
			if "2000" in cpu_string and os.path.exists('/root/cd-mnt/预装软件/2000') and os.path.exists('/root/cd-mnt/预装软件/1500'):
				os.system("mv /var/softmanager/preinstall-tmp/预装软件/2000/* /var/softmanager/preinstall-tmp/ && mv /var/softmanager/preinstall-tmp/预装软件/*.deb /var/softmanager/preinstall-tmp/ && rm /var/softmanager/preinstall-tmp/预装软件/ -rf && mv /var/softmanager/preinstall-tmp/ /var/softmanager/preinstall/")
			elif "1500" in cpu_string and os.path.exists('/root/cd-mnt/预装软件/2000') and os.path.exists('/root/cd-mnt/预装软件/1500'):
				os.system("mv /var/softmanager/preinstall-tmp/预装软件/1500/* /var/softmanager/preinstall-tmp/ && mv /var/softmanager/preinstall-tmp/预装软件/*.deb /var/softmanager/preinstall-tmp/ && rm /var/softmanager/preinstall-tmp/预装软件/ -rf && mv /var/softmanager/preinstall-tmp/ /var/softmanager/preinstall/")
			elif "3000" in cpu_string and os.path.exists('/root/cd-mnt/预装软件/3000') and os.path.exists('/root/cd-mnt/预装软件/4000'):
				os.system("mv /var/softmanager/preinstall-tmp/预装软件/3000/* /var/softmanager/preinstall-tmp/ && mv /var/softmanager/preinstall-tmp/预装软件/*.deb /var/softmanager/preinstall-tmp/ && rm /var/softmanager/preinstall-tmp/预装软件/ -rf && mv /var/softmanager/preinstall-tmp/ /var/softmanager/preinstall/")
			elif "4000" in cpu_string and os.path.exists('/root/cd-mnt/预装软件/3000') and os.path.exists('/root/cd-mnt/预装软件/4000'):
				os.system("mv /var/softmanager/preinstall-tmp/预装软件/4000/* /var/softmanager/preinstall-tmp/ && mv /var/softmanager/preinstall-tmp/预装软件/*.deb /var/softmanager/preinstall-tmp/ && rm /var/softmanager/preinstall-tmp/预装软件/ -rf && mv /var/softmanager/preinstall-tmp/ /var/softmanager/preinstall/")
			os._exit(0)
		os.waitpid(child, 0)
		os.system("chown secadm.secadm -R /var/softmanager")
		os.system("chmod 777 -R /var/softmanager")
		os.system("notify-send '预装软件包同步完毕，重启系统后请通过安全管理员登录，在预选工具里进行选择安装!'")
		os.system("umount /root/cd-mnt -l")
		os.system("rm /root/cd-mnt -rf")
		os.system("eject")


if __name__ == '__main__':

	DBusGMainLoop(set_as_default=True)
	sessionbus=dbus.SessionBus()
	sessionbus.add_signal_receiver(signal_name="MountAdded",dbus_interface="org.gtk.Private.RemoteVolumeMonitor",path="/org/gtk/Private/RemoteVolumeMonitor",bus_name=None,handler_function=mount_added)
	loop=gobject.MainLoop()
	loop.run()

